Subject: Invisible profiling, or profiling a generic program.

From: Omer Musaev <[email-masked]>
Date: Tue, 4 Jun 2002 10:05:40 +0300

An article ( http://www.cs.rpi.edu/~musser/gp/timing.html ) explains approach 
and techniques used in creation of Counting Adaptors - a generic components 
that can be used to perform op-counting on generic algorithms.

Nice hack:)
Omer

---

From: Omer Musaev <[email-masked]>
Date: Tue, 4 Jun 2002 10:24:41 +0300

On Tuesday 04 June 2002 10:05, Omer Musaev wrote:
> An article ( http://www.cs.rpi.edu/~musser/gp/timing.html ) explains
> approach and techniques used in creation of Counting Adaptors - a generic
> components that can be used to perform op-counting on generic algorithms.
>

Errata:

I guess that word 'generic' is too generic to mean something specific, 
yet I intended to be very specific... :(

Generic algorithm is an function (sic!) that implements an algorithm and
has a following property - it is aware of concept of a container that it
should work on, and not a type. In C++ generic algorithms are usualy
implemented as a template functions.

As an example, generic algorithm named "find" implements a linear search
algorithm. That algorithm depends on notion of forward iteration on a 
container, and doesn't care if the specific container that it works on 
is an array, list or dequeue.

For nice introduction to generic algorithms look at STL manual.

Having said that, I admit that "generic algorithms" is not close to be 
"any algorithm", but rather "generous algorithm", or something like that:)

>
> Nice hack:)
> Omer
>
>
>
>
>
> To unsubscribe from this group, send an email to:
> [email-masked]
>
>
>
> Your use of Yahoo! Groups is subject to http://docs.yahoo.com/info/terms/

---

From: Oleg Goldshmidt <[email-masked]>
Date: 04 Jun 2002 12:07:24 +0300

Omer Musaev <[email-masked]> writes:

> yet I intended to be very specific...

IIRC, it was the famous British mathematician Littlewood (Nadav, you
know such things) who suggested the following: there are two kinds of
adjectives, those that possess the quality they describe
(e.g. "expressive") and those that don't (e.g. "red"). Let's dub them
"homological" and "heterological", respectively (I don't remember what
[fictitious] terms Littlewood used, homology is a term in topology, so
it is likely Littlewood used it).

Exercise: to which type do the following adjectives belong:

1) generic
2) specific
3) homological
4) heterological

?

-- 
Oleg Goldshmidt | [email-masked] 
"A sense of the fundamental decencies is parceled out unequally at birth."